CREATE OR REPLACE TRIGGER LOG_EXP_PAREXPEDICAO
AFTER DELETE OR INSERT OR UPDATE
ON PAREXPEDICAO FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(2000);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';
   V_CONT_LENGTH  := 1;
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_NRINCREST    := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

      IF INSERTING THEN

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:NEW.CDFILIAL,'') || ' ';
         END IF;
         IF :NEW.IDPERADIEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Permisso para expedir qtde adicional = ' || NVL(:NEW.IDPERADIEXP,'') || ' ';
         END IF;
         IF :NEW.VRPEADIEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Vr adicional permitido = ' || NVL(:NEW.VRPEADIEXP,'') || '% ';
         END IF;
         IF :NEW.VRPELIQEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Vr. de replicao do documento (NF) = ' || NVL(:NEW.VRPELIQEXP,'') || '% ';
         END IF;
         IF :NEW.IDGERAREPLIC IS NOT NULL THEN
            V_DESC := V_DESC || 'Gera replicao do documento (NF) = ' || NVL(:NEW.IDGERAREPLIC,'') || ' ';
         END IF;
         IF :NEW.IDRETPROEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Retirada de produtos do estoque = ' || NVL(:NEW.IDRETPROEXP,'') || ' ';
         END IF;
         IF :NEW.IDTPCADCLIEX IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de cadastro de cliente = ' || NVL(:NEW.IDTPCADCLIEX,'') || ' ';
         END IF;
         IF :NEW.IDGERAFINANC IS NOT NULL THEN
            V_DESC := V_DESC || 'Gera documentos aprovados = ' || NVL(:NEW.IDGERAFINANC,'') || ' ';
         END IF;
         IF :NEW.CDIMPOSTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Imposto = ' || NVL(:NEW.CDIMPOSTO,'') || ' ';
         END IF;
         IF :NEW.IDCTRLVENEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Controle por vendedor = ' || NVL(:NEW.IDCTRLVENEXP,'') || ' ';
         END IF;
         IF :NEW.IDNFPEDIDO IS NOT NULL THEN
            V_DESC := V_DESC || 'Quebra de NFs por pedido = ' || NVL(:NEW.IDNFPEDIDO,'') || ' ';
         END IF;
         IF :NEW.IDCUSEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Custo na Expedio = ' || NVL(:NEW.IDCUSEXP,'') || ' ';
         END IF;
         IF :NEW.IDGERPRODEST IS NOT NULL THEN
            V_DESC := V_DESC || 'Gera NF com cdigos de produtos de estoque = ' || NVL(:NEW.IDGERPRODEST,'') || ' ';
         END IF;
         IF :NEW.IDREPLITRANS IS NOT NULL THEN
            V_DESC := V_DESC || 'Replica transportadora = ' || NVL(:NEW.IDREPLITRANS,'') || ' ';
         END IF;
         IF :NEW.CDGROPERTROC IS NOT NULL THEN
            V_DESC := V_DESC || 'Grupo de Operadores para troca de produtos = ' || NVL(:NEW.CDGROPERTROC,'') || ' ';
         END IF;
         IF :NEW.IDEVOLESTTRO IS NOT NULL THEN
            V_DESC := V_DESC || 'Evoluo automtica de estoque = ' || NVL(:NEW.IDEVOLESTTRO,'') || ' ';
         END IF;
         IF :NEW.IDEXPQTDISP IS NOT NULL THEN
            V_DESC := V_DESC || 'Expedio automtica para produtos c/ estoque = ' || NVL(:NEW.IDEXPQTDISP,'') || ' ';
         END IF;
         IF :NEW.CDTPCTPAGFRE IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de conta para frete = ' || NVL(:NEW.CDTPCTPAGFRE,'') || ' ';
         END IF;
         IF :NEW.VRPECOGEREXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Vr. de comisso gerado = ' || NVL(:NEW.VRPECOGEREXP,'') || '% ';
         END IF;
         IF :NEW.DSCODIGOUTILIZA IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo de Utilizao de Mapas = ' || NVL(:NEW.DSCODIGOUTILIZA,'') || ' ';
         END IF;
         IF :NEW.IDEXIDIAENTREGA IS NOT NULL THEN
            V_DESC := V_DESC || 'Exibe Filtro de Dias de Entrega = ' || NVL(:NEW.IDEXIDIAENTREGA,'') || ' ';
         END IF;
         IF :NEW.IDEXITRANSPDIST IS NOT NULL THEN
            V_DESC := V_DESC || 'Exibe Transportadora na Grade de Distribuio = ' || NVL(:NEW.IDEXITRANSPDIST,'') || ' ';
         END IF;
         IF :NEW.IDEMPRESANFEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Exibe Empresa da Nota Fiscal = ' || NVL(:NEW.IDEMPRESANFEXP,'') || ' ';
         END IF;
         IF :NEW.IDSEPARADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Utiliza Separador = ' || NVL(:NEW.IDSEPARADOR,'') || ' ';
         END IF;
         IF :NEW.IDCONFERENTE IS NOT NULL THEN
            V_DESC := V_DESC || 'Utiliza Conferente = ' || NVL(:NEW.IDCONFERENTE,'') || ' ';
         END IF;
         IF :NEW.CDTIPTRANS IS NOT NULL THEN
            V_DESC := V_DESC || 'Transportadora = ' || NVL(:NEW.CDTIPTRANS,'') || ' ';
         END IF;
         IF :NEW.IDTPIJURTRAN IS NOT NULL THEN
            V_DESC := V_DESC || ' Tipo de inscrio= ' || NVL(:NEW.IDTPIJURTRAN,'') || ' ';
         END IF;
         IF :NEW.NRINSJURTRAN IS NOT NULL THEN
            V_DESC := V_DESC || ' Inscrio jurdica = ' || NVL(:NEW.NRINSJURTRAN,'') || ' ';
         END IF;
         IF :NEW.VRPERLOTACAO IS NOT NULL THEN
            V_DESC := V_DESC || ' Vr. para aviso de lotao = ' || NVL(:NEW.VRPERLOTACAO,'') || '% ';
         END IF;
         IF :NEW.IDCANCELAITEM IS NOT NULL THEN
            V_DESC := V_DESC || ' Cancela produtos s/ estoque = ' || NVL(:NEW.IDCANCELAITEM,'') || ' ';
         END IF;
         IF :NEW.IDCRTLVEICULO IS NOT NULL THEN
            V_DESC := V_DESC || ' Controle de veculos = ' || NVL(:NEW.IDCRTLVEICULO,'') || ' ';
         END IF;
         IF :NEW.IDBLOQUEIAPESO IS NOT NULL THEN
            V_DESC := V_DESC || ' Bloqueia alterao no peso = ' || NVL(:NEW.IDBLOQUEIAPESO,'') || ' ';
         END IF;
         IF :NEW.DSACREMISPERDA IS NOT NULL THEN
            V_DESC := V_DESC || ' Emisso de produtos de perda = ' || NVL(:NEW.DSACREMISPERDA,'') || ' ';
         END IF;
         IF :NEW.IDENTSAIOPPERDA IS NOT NULL THEN
            V_DESC := V_DESC || ' Operao E/S para perda = ' || NVL(:NEW.IDENTSAIOPPERDA,'') || ' ';
         END IF;
         IF :NEW.IDENTSAIOPSOBRA IS NOT NULL THEN
            V_DESC := V_DESC || ' Operao E/S para sobra = ' || NVL(:NEW.IDENTSAIOPSOBRA,'') || ' ';
         END IF;
         IF :NEW.CDTPOPERPERDA IS NOT NULL THEN
            V_DESC := V_DESC || ' Tipo de operao de perda = ' || NVL(:NEW.CDTPOPERPERDA,'') || ' ';
         END IF;
         IF :NEW.CDTPOPERSOBRA IS NOT NULL THEN
            V_DESC := V_DESC || ' Tipo de operao de sobra = ' || NVL(:NEW.CDTPOPERSOBRA,'') || ' ';
         END IF;
         IF :NEW.IDBLOQUOPTERC IS NOT NULL THEN
            V_DESC := V_DESC || ' Bloquear expedio de terc. s/ OP = ' || NVL(:NEW.IDBLOQUOPTERC,'') || ' ';
         END IF;
         IF :NEW.IDUTILALMOXTERC IS NOT NULL THEN
            V_DESC := V_DESC || ' Expedio de terc. utilizar estoque de terc. = ' || NVL(:NEW.IDUTILALMOXTERC,'') || ' ';
         END IF;
         IF :NEW.IDCOMISPERIODO IS NOT NULL THEN
            V_DESC := V_DESC || ' Comisso do vendedor por perodo = ' || NVL(:NEW.IDCOMISPERIODO,'') || ' ';
         END IF;
         IF :NEW.VRPERCOMEXP IS NOT NULL THEN
            V_DESC := V_DESC || ' Vr. de comisso na expedio (EXP) = ' || NVL(:NEW.VRPERCOMEXP,'') || '% ';
         END IF;
         IF :NEW.VRPERCOMREC IS NOT NULL THEN
            V_DESC := V_DESC || ' Vr. de comisso na baixa (REC) = ' || NVL(:NEW.VRPERCOMREC,'') || '% ';
         END IF;
         IF :NEW.IDUTSEPPEDEXP IS NOT NULL THEN
            V_DESC := V_DESC || ' Ut. Sep. Exp. = ' || NVL(:NEW.IDUTSEPPEDEXP,'') || ' ';
         END IF;            
         IF :NEW.IDGRAVAENDENTPEDNF IS NOT NULL THEN
            V_DESC := V_DESC || ' Grava endereo de entrega do pedido nos dados adicionais da nota = ' || NVL(:NEW.IDGRAVAENDENTPEDNF,'') || ' ';
         END IF;
         
        IF :NEW.IDICMSCOMISS IS NOT NULL THEN
            V_DESC := V_DESC || ' Considera ICMS-ST no calculo da comissao= ' || NVL(:NEW.IDICMSCOMISS,'') || ' ';
         END IF;
         
         IF :NEW.IDIMPDESOCOMISS IS NOT NULL THEN
            V_DESC := V_DESC || ' Abate imposto desonerado do clculo da comisso = ' || NVL(:NEW.IDIMPDESOCOMISS,'') || ' ';
         END IF;
         
         IF :NEW.IDCOMISBAIXATOT IS NOT NULL THEN
            V_DESC := V_DESC || ' Calc. Comissao na baixa total do titulo= ' || NVL(:NEW.IDCOMISBAIXATOT,'') || ' ';
         END IF;
        
         V_ITPESQ     := :NEW.CDFILIAL;
         V_IDTIPOOPER := '1';

   ELSE

      IF UPDATING THEN

         IF :NEW.CDFILIAL <> :OLD.CDFILIAL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:NEW.CDFILIAL,'') || ' ';
         END IF;
         IF :NEW.IDPERADIEXP <> :OLD.IDPERADIEXP THEN
            V_DESC := V_DESC || 'Permisso para expedir qtde adicional = ' || NVL(:NEW.IDPERADIEXP,'') || ' ';
         END IF;
         IF :NEW.VRPEADIEXP <> :OLD.VRPEADIEXP THEN
            V_DESC := V_DESC || 'Vr adicional permitido = ' || NVL(:NEW.VRPEADIEXP,'') || '% ';
         END IF;
         IF :NEW.VRPELIQEXP <> :OLD.VRPELIQEXP THEN
            V_DESC := V_DESC || 'Vr. de replicao do documento (NF) = ' || NVL(:NEW.VRPELIQEXP,'') || '% ';
         END IF;
         IF :NEW.IDGERAREPLIC <> :OLD.IDGERAREPLIC THEN
            V_DESC := V_DESC || 'Gera replicao do documento (NF) = ' || NVL(:NEW.IDGERAREPLIC,'') || ' ';
         END IF;
         IF :NEW.IDRETPROEXP <> :OLD.IDRETPROEXP THEN
            V_DESC := V_DESC || 'Retirada de produtos do estoque = ' || NVL(:NEW.IDRETPROEXP,'') || ' ';
         END IF;
         IF :NEW.IDTPCADCLIEX <> :OLD.IDTPCADCLIEX THEN
            V_DESC := V_DESC || 'Tipo de cadastro de cliente = ' || NVL(:NEW.IDTPCADCLIEX,'') || ' ';
         END IF;
         IF :NEW.IDGERAFINANC <> :OLD.IDGERAFINANC THEN
            V_DESC := V_DESC || 'Gera documentos aprovados = ' || NVL(:NEW.IDGERAFINANC,'') || ' ';
         END IF;
         IF :NEW.CDIMPOSTO <> :OLD.CDIMPOSTO THEN
            V_DESC := V_DESC || 'Imposto = ' || NVL(:NEW.CDIMPOSTO,'') || ' ';
         END IF;
         IF :NEW.IDCTRLVENEXP <> :OLD.IDCTRLVENEXP THEN
            V_DESC := V_DESC || 'Controle por vendedor = ' || NVL(:NEW.IDCTRLVENEXP,'') || ' ';
         END IF;
         IF :NEW.IDNFPEDIDO <> :OLD.IDNFPEDIDO THEN
            V_DESC := V_DESC || 'Quebra de NFs por pedido = ' || NVL(:NEW.IDNFPEDIDO,'') || ' ';
         END IF;
         IF :NEW.IDCUSEXP <> :OLD.IDCUSEXP THEN
            V_DESC := V_DESC || 'Custo na Expedio = ' || NVL(:NEW.IDCUSEXP,'') || ' ';
         END IF;
         IF :NEW.IDGERPRODEST <> :OLD.IDGERPRODEST THEN
            V_DESC := V_DESC || 'Gera NF com cdigos de produtos de estoque = ' || NVL(:NEW.IDGERPRODEST,'') || ' ';
         END IF;
         IF :NEW.IDREPLITRANS <> :OLD.IDREPLITRANS THEN
            V_DESC := V_DESC || 'Replica transportadora = ' || NVL(:NEW.IDREPLITRANS,'') || ' ';
         END IF;
         IF :NEW.CDGROPERTROC <> :OLD.CDGROPERTROC THEN
            V_DESC := V_DESC || 'Grupo de Operadores para troca de produtos = ' || NVL(:NEW.CDGROPERTROC,'') || ' ';
         END IF;
         IF :NEW.IDEVOLESTTRO <> :OLD.IDEVOLESTTRO THEN
            V_DESC := V_DESC || 'Evoluo automtica de estoque = ' || NVL(:NEW.IDEVOLESTTRO,'') || ' ';
         END IF;
         IF :NEW.IDEXPQTDISP <> :OLD.IDEXPQTDISP THEN
            V_DESC := V_DESC || 'Expedio automtica para produtos c/ estoque = ' || NVL(:NEW.IDEXPQTDISP,'') || ' ';
         END IF;
         IF :NEW.CDTPCTPAGFRE <> :OLD.CDTPCTPAGFRE THEN
            V_DESC := V_DESC || 'Tipo de conta para frete = ' || NVL(:NEW.CDTPCTPAGFRE,'') || ' ';
         END IF;
         IF :NEW.VRPECOGEREXP <> :OLD.VRPECOGEREXP THEN
            V_DESC := V_DESC || 'Vr. de comisso gerado = ' || NVL(:NEW.VRPECOGEREXP,'') || '% ';
         END IF;
         IF :NEW.DSCODIGOUTILIZA <> :OLD.DSCODIGOUTILIZA THEN
            V_DESC := V_DESC || 'Cdigo de Utilizao de Mapas = ' || NVL(:NEW.DSCODIGOUTILIZA,'') || ' ';
         END IF;
         IF :NEW.IDEXIDIAENTREGA <> :OLD.IDEXIDIAENTREGA  THEN
            V_DESC := V_DESC || 'Exibe Filtro de Dias de Entrega = ' || NVL(:NEW.IDEXIDIAENTREGA,'') || ' ';
         END IF;
         IF :NEW.IDEXITRANSPDIST <> :OLD.IDEXITRANSPDIST THEN
            V_DESC := V_DESC || 'Exibe Transportadora na Grade de Distribuio = ' || NVL(:NEW.IDEXITRANSPDIST,'') || ' ';
         END IF;
         IF :NEW.IDEMPRESANFEXP <> :OLD.IDEMPRESANFEXP THEN
            V_DESC := V_DESC || 'Exibe Empresa da Nota Fiscal = ' || NVL(:NEW.IDEMPRESANFEXP,'') || ' ';
         END IF;
         IF :NEW.IDSEPARADOR <> :OLD.IDSEPARADOR THEN
            V_DESC := V_DESC || 'Utiliza Separador = ' || NVL(:NEW.IDSEPARADOR,'') || ' ';
         END IF;
         IF :NEW.IDCONFERENTE <> :OLD.IDCONFERENTE THEN
            V_DESC := V_DESC || 'Utiliza Conferente = ' || NVL(:NEW.IDCONFERENTE,'') || ' ';
         END IF;
         IF :NEW.CDTIPTRANS <> :OLD.CDTIPTRANS THEN
            V_DESC := V_DESC || 'Transportadora = ' || NVL(:NEW.CDTIPTRANS,'') || ' ';
         END IF;
         IF :NEW.IDTPIJURTRAN <> :OLD.IDTPIJURTRAN THEN
            V_DESC := V_DESC || ' Tipo de inscrio= ' || NVL(:NEW.IDTPIJURTRAN,'') || ' ';
         END IF;
         IF :NEW.NRINSJURTRAN <> :OLD.NRINSJURTRAN THEN
            V_DESC := V_DESC || ' Inscrio jurdica = ' || NVL(:NEW.NRINSJURTRAN,'') || ' ';
         END IF;
         IF :NEW.VRPERLOTACAO <> :OLD.NRINSJURTRAN THEN
            V_DESC := V_DESC || ' Vr. para aviso de lotao = ' || NVL(:NEW.VRPERLOTACAO,'') || '% ';
         END IF;
         IF :NEW.IDCANCELAITEM <> :OLD.IDCANCELAITEM THEN
            V_DESC := V_DESC || ' Cancela produtos s/ estoque = ' || NVL(:NEW.IDCANCELAITEM,'') || ' ';
         END IF;
         IF :NEW.IDCRTLVEICULO <> :OLD.IDCRTLVEICULO THEN
            V_DESC := V_DESC || ' Controle de veculos = ' || NVL(:NEW.IDCRTLVEICULO,'') || ' ';
         END IF;
         IF :NEW.IDBLOQUEIAPESO <> :OLD.IDBLOQUEIAPESO THEN
            V_DESC := V_DESC || ' Bloqueia alterao no peso = ' || NVL(:NEW.IDBLOQUEIAPESO,'') || ' ';
         END IF;
         IF :NEW.DSACREMISPERDA <> :OLD.DSACREMISPERDA THEN
            V_DESC := V_DESC || ' Emisso de produtos de perda = ' || NVL(:NEW.DSACREMISPERDA,'') || ' ';
         END IF;
         IF :NEW.IDENTSAIOPPERDA <> :OLD.IDENTSAIOPPERDA THEN
            V_DESC := V_DESC || ' Operao E/S para perda = ' || NVL(:NEW.IDENTSAIOPPERDA,'') || ' ';
         END IF;
         IF :NEW.IDENTSAIOPSOBRA <> :OLD.IDENTSAIOPSOBRA THEN
            V_DESC := V_DESC || ' Operao E/S para sobra = ' || NVL(:NEW.IDENTSAIOPSOBRA,'') || ' ';
         END IF;
         IF :NEW.CDTPOPERPERDA <> :OLD.CDTPOPERPERDA THEN
            V_DESC := V_DESC || ' Tipo de operao de perda = ' || NVL(:NEW.CDTPOPERPERDA,'') || ' ';
         END IF;
         IF :NEW.CDTPOPERSOBRA <> :OLD.CDTPOPERSOBRA THEN
            V_DESC := V_DESC || ' Tipo de operao de sobra = ' || NVL(:NEW.CDTPOPERSOBRA,'') || ' ';
         END IF;
         IF :NEW.IDBLOQUOPTERC <> :OLD.IDBLOQUOPTERC THEN
            V_DESC := V_DESC || ' Bloquear expedio de terc. s/ OP = ' || NVL(:NEW.IDBLOQUOPTERC,'') || ' ';
         END IF;
         IF :NEW.IDUTILALMOXTERC <> :OLD.IDUTILALMOXTERC THEN
            V_DESC := V_DESC || ' Expedio de terc. utilizar estoque de terc. = ' || NVL(:NEW.IDUTILALMOXTERC,'') || ' ';
         END IF;
         IF :NEW.IDCOMISPERIODO <> :OLD.IDCOMISPERIODO THEN
            V_DESC := V_DESC || ' Comisso do vendedor por perodo = ' || NVL(:NEW.IDCOMISPERIODO,'') || ' ';
         END IF;
         IF :NEW.VRPERCOMEXP <> :OLD.VRPERCOMEXP THEN
            V_DESC := V_DESC || ' Vr. de comisso na expedio (EXP) = ' || NVL(:NEW.VRPERCOMEXP,'') || '% ';
         END IF;
         IF :NEW.VRPERCOMREC <> :OLD.VRPERCOMREC THEN
            V_DESC := V_DESC || ' Vr. de comisso na baixa (REC) = ' || NVL(:NEW.VRPERCOMREC,'') || '% ';
         END IF;
         IF :NEW.IDUTSEPPEDEXP <> :OLD.IDUTSEPPEDEXP THEN
            V_DESC := V_DESC || ' Ut. Sep. Exp. = ' || NVL(:NEW.IDUTSEPPEDEXP,'') || ' ';
         END IF;
         IF :NEW.IDGRAVAENDENTPEDNF <> :OLD.IDGRAVAENDENTPEDNF THEN
            V_DESC := V_DESC || ' Grava endereo de entrega do pedido nos dados adicionais da nota = ' || NVL(:NEW.IDGRAVAENDENTPEDNF,'') || ' ';
         END IF;
         
        IF :NEW.IDICMSCOMISS <> :OLD.IDICMSCOMISS THEN
            V_DESC := V_DESC || ' Considera ICMS-ST no calculo da comissao= ' || NVL(:OLD.IDICMSCOMISS,'') || ' ';
         END IF;
          
         IF :NEW.IDIMPDESOCOMISS <> :OLD.IDIMPDESOCOMISS THEN
            V_DESC := V_DESC || ' Abate imposto desonerado do clculo da comisso = ' || NVL(:NEW.IDIMPDESOCOMISS,'') || ' ';
         END IF;
         
         IF :NEW.IDCOMISBAIXATOT <> :OLD.IDCOMISBAIXATOT THEN
            V_DESC := V_DESC || ' Calc. Comissao na baixa total do titulo= ' || NVL(:NEW.IDCOMISBAIXATOT,'') || ' ';
         END IF;

         V_ITPESQ     := :NEW.CDFILIAL;
         V_IDTIPOOPER := '2';

      END IF;

      IF DELETING  THEN

         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:OLD.CDFILIAL,'') || ' ';
         END IF;
         IF :OLD.IDPERADIEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Permisso para expedir qtde adicional = ' || NVL(:OLD.IDPERADIEXP,'') || ' ';
         END IF;
         IF :OLD.VRPEADIEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Vr adicional permitido = ' || NVL(:OLD.VRPEADIEXP,'') || '% ';
         END IF;
         IF :OLD.VRPELIQEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Vr. de replicao do documento (NF) = ' || NVL(:OLD.VRPELIQEXP,'') || '% ';
         END IF;
         IF :OLD.IDGERAREPLIC IS NOT NULL THEN
            V_DESC := V_DESC || 'Gera replicao do documento (NF) = ' || NVL(:OLD.IDGERAREPLIC,'') || ' ';
         END IF;
         IF :OLD.IDRETPROEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Retirada de produtos do estoque = ' || NVL(:OLD.IDRETPROEXP,'') || ' ';
         END IF;
         IF :OLD.IDTPCADCLIEX IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de cadastro de cliente = ' || NVL(:OLD.IDTPCADCLIEX,'') || ' ';
         END IF;
         IF :OLD.IDGERAFINANC IS NOT NULL THEN
            V_DESC := V_DESC || 'Gera documentos aprovados = ' || NVL(:OLD.IDGERAFINANC,'') || ' ';
         END IF;
         IF :OLD.CDIMPOSTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Imposto = ' || NVL(:OLD.CDIMPOSTO,'') || ' ';
         END IF;
         IF :OLD.IDCTRLVENEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Controle por vendedor = ' || NVL(:OLD.IDCTRLVENEXP,'') || ' ';
         END IF;
         IF :OLD.IDNFPEDIDO IS NOT NULL THEN
            V_DESC := V_DESC || 'Quebra de NFs por pedido = ' || NVL(:OLD.IDNFPEDIDO,'') || ' ';
         END IF;
         IF :OLD.IDCUSEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Custo na Expedio = ' || NVL(:OLD.IDCUSEXP,'') || ' ';
         END IF;
         IF :OLD.IDGERPRODEST IS NOT NULL THEN
            V_DESC := V_DESC || 'Gera NF com cdigos de produtos de estoque = ' || NVL(:OLD.IDGERPRODEST,'') || ' ';
         END IF;
         IF :OLD.IDREPLITRANS IS NOT NULL THEN
            V_DESC := V_DESC || 'Replica transportadora = ' || NVL(:OLD.IDREPLITRANS,'') || ' ';
         END IF;
         IF :OLD.CDGROPERTROC IS NOT NULL THEN
            V_DESC := V_DESC || 'Grupo de Operadores para troca de produtos = ' || NVL(:OLD.CDGROPERTROC,'') || ' ';
         END IF;
         IF :OLD.IDEVOLESTTRO IS NOT NULL THEN
            V_DESC := V_DESC || 'Evoluo automtica de estoque = ' || NVL(:OLD.IDEVOLESTTRO,'') || ' ';
         END IF;
         IF :OLD.IDEXPQTDISP IS NOT NULL THEN
            V_DESC := V_DESC || 'Expedio automtica para produtos c/ estoque = ' || NVL(:OLD.IDEXPQTDISP,'') || ' ';
         END IF;
         IF :OLD.CDTPCTPAGFRE IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de conta para frete = ' || NVL(:OLD.CDTPCTPAGFRE,'') || ' ';
         END IF;
         IF :OLD.VRPECOGEREXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Vr. de comisso gerado = ' || NVL(:OLD.VRPECOGEREXP,'') || '% ';
         END IF;
         IF :OLD.DSCODIGOUTILIZA IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo de Utilizao de Mapas = ' || NVL(:OLD.DSCODIGOUTILIZA,'') || ' ';
         END IF;
         IF :OLD.IDEXIDIAENTREGA IS NOT NULL THEN
            V_DESC := V_DESC || 'Exibe Filtro de Dias de Entrega = ' || NVL(:OLD.IDEXIDIAENTREGA,'') || ' ';
         END IF;
         IF :OLD.IDEXITRANSPDIST IS NOT NULL THEN
            V_DESC := V_DESC || 'Exibe Transportadora na Grade de Distribuio = ' || NVL(:OLD.IDEXITRANSPDIST,'') || ' ';
         END IF;
         IF :OLD.IDEMPRESANFEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Exibe Empresa da Nota Fiscal = ' || NVL(:OLD.IDEMPRESANFEXP,'') || ' ';
         END IF;
         IF :OLD.IDSEPARADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Utiliza Separador = ' || NVL(:OLD.IDSEPARADOR,'') || ' ';
         END IF;
         IF :OLD.IDCONFERENTE IS NOT NULL THEN
            V_DESC := V_DESC || 'Utiliza Conferente = ' || NVL(:OLD.IDCONFERENTE,'') || ' ';
         END IF;
         IF :OLD.CDTIPTRANS IS NOT NULL THEN
            V_DESC := V_DESC || 'Transportadora = ' || NVL(:OLD.CDTIPTRANS,'') || ' ';
         END IF;
         IF :OLD.IDTPIJURTRAN IS NOT NULL THEN
            V_DESC := V_DESC || ' Tipo de inscrio= ' || NVL(:OLD.IDTPIJURTRAN,'') || ' ';
         END IF;
         IF :OLD.NRINSJURTRAN IS NOT NULL THEN
            V_DESC := V_DESC || ' Inscrio jurdica = ' || NVL(:OLD.NRINSJURTRAN,'') || ' ';
         END IF;
         IF :OLD.VRPERLOTACAO IS NOT NULL THEN
            V_DESC := V_DESC || ' Vr. para aviso de lotao = ' || NVL(:OLD.VRPERLOTACAO,'') || '% ';
         END IF;
         IF :OLD.IDCANCELAITEM IS NOT NULL THEN
            V_DESC := V_DESC || ' Cancela produtos s/ estoque = ' || NVL(:OLD.IDCANCELAITEM,'') || ' ';
         END IF;
         IF :OLD.IDCRTLVEICULO IS NOT NULL THEN
            V_DESC := V_DESC || ' Controle de veculos = ' || NVL(:OLD.IDCRTLVEICULO,'') || ' ';
         END IF;
         IF :OLD.IDBLOQUEIAPESO IS NOT NULL THEN
            V_DESC := V_DESC || ' Bloqueia alterao no peso = ' || NVL(:OLD.IDBLOQUEIAPESO,'') || ' ';
         END IF;
         IF :OLD.DSACREMISPERDA IS NOT NULL THEN
            V_DESC := V_DESC || ' Emisso de produtos de perda = ' || NVL(:OLD.DSACREMISPERDA,'') || ' ';
         END IF;
         IF :OLD.IDENTSAIOPPERDA IS NOT NULL THEN
            V_DESC := V_DESC || ' Operao E/S para perda = ' || NVL(:OLD.IDENTSAIOPPERDA,'') || ' ';
         END IF;
         IF :OLD.IDENTSAIOPSOBRA IS NOT NULL THEN
            V_DESC := V_DESC || ' Operao E/S para sobra = ' || NVL(:OLD.IDENTSAIOPSOBRA,'') || ' ';
         END IF;
         IF :OLD.CDTPOPERPERDA IS NOT NULL THEN
            V_DESC := V_DESC || ' Tipo de operao de perda = ' || NVL(:OLD.CDTPOPERPERDA,'') || ' ';
         END IF;
         IF :OLD.CDTPOPERSOBRA IS NOT NULL THEN
            V_DESC := V_DESC || ' Tipo de operao de sobra = ' || NVL(:OLD.CDTPOPERSOBRA,'') || ' ';
         END IF;
         IF :OLD.IDBLOQUOPTERC IS NOT NULL THEN
            V_DESC := V_DESC || ' Bloquear expedio de terc. s/ OP = ' || NVL(:OLD.IDBLOQUOPTERC,'') || ' ';
         END IF;
         IF :OLD.IDUTILALMOXTERC IS NOT NULL THEN
            V_DESC := V_DESC || ' Expedio de terc. utilizar estoque de terc. = ' || NVL(:OLD.IDUTILALMOXTERC,'') || ' ';
         END IF;
         IF :OLD.IDCOMISPERIODO IS NOT NULL THEN
            V_DESC := V_DESC || ' Comisso do vendedor por perodo = ' || NVL(:OLD.IDCOMISPERIODO,'') || ' ';
         END IF;
         IF :OLD.VRPERCOMEXP IS NOT NULL THEN
            V_DESC := V_DESC || ' Vr. de comisso na expedio (EXP) = ' || NVL(:OLD.VRPERCOMEXP,'') || '% ';
         END IF;
         IF :OLD.VRPERCOMREC IS NOT NULL THEN
            V_DESC := V_DESC || ' Vr. de comisso na baixa (REC) = ' || NVL(:OLD.VRPERCOMREC,'') || '% ';
         END IF;
         IF :OLD.IDUTSEPPEDEXP IS NOT NULL THEN
            V_DESC := V_DESC || ' Ut. Sep. Exp. = ' || NVL(:OLD.IDUTSEPPEDEXP,'') || ' ';
         END IF;
         IF :OLD.IDGRAVAENDENTPEDNF IS NOT NULL THEN
            V_DESC := V_DESC || ' Grava endereo de entrega do pedido nos dados adicionais da nota = ' || NVL(:OLD.IDGRAVAENDENTPEDNF,'') || ' ';
         END IF;
         
         IF :OLD.IDICMSCOMISS IS NOT NULL THEN
            V_DESC := V_DESC || ' Considera ICMS-ST no calculo da comissao= ' || NVL(:OLD.IDICMSCOMISS,'') || ' ';
         END IF;
         
         IF :OLD.IDIMPDESOCOMISS IS NOT NULL THEN
            V_DESC := V_DESC || ' Abate imposto desonerado do clculo da comisso = ' || NVL(:OLD.IDIMPDESOCOMISS,'') || ' ';
         END IF;
         
        IF :OLD.IDCOMISBAIXATOT IS NOT NULL THEN
            V_DESC := V_DESC || ' Calc. Comissao na baixa total do titulo= ' || NVL(:OLD.IDCOMISBAIXATOT,'') || ' ';
         END IF;
         
         V_ITPESQ     := :OLD.CDFILIAL;
         V_IDTIPOOPER := '3';

      END IF;
      
   END IF;

   IF NOT (V_DESC IS NULL) THEN

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA,     DTOPERACAO,   NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO,   CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER,  CDFILLOGOPER)
                       VALUES  ('PAREXPEDICAO', SYSDATE,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   V_GRAV_DESC,    V_ITPESQ,
                                V_DSSERVERRDM,  V_DSREMOTEADDR, V_DSREMOTEHOST,
                                V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);

      END LOOP;
   END IF;
END;
/